// copyright(C) KatsuhikoTerawaki CA co.,ltd
//---------------------------
// PSoC5 Includes
//---------------------------
#include <project.h>
//---------------------------
// RTOS Includes
//---------------------------
#include "FreeRTOS.h"
#include "task.h"
#include "queue.h"
#include "semphr.h"

//---------------------------
// API Includes
//---------------------------
#include "mydefine.h"
#include "xprintf.h"
#include "I2C_1.h" //ꂽ include

BOOL InitI2C( void )
{
    I2C_1_Start();
    return TRUE ;
}

BOOL WriteRegI2C(uint8 deviceAdrs, uint8 adrs, uint8 data)
{
    uint8 status;
    BOOL error = TRUE ;

    status = I2C_1_I2CMasterSendStart(deviceAdrs, I2C_1_I2C_WRITE_XFER_MODE);
    if(status == I2C_1_I2C_MSTR_NO_ERROR) {
        status = I2C_1_I2CMasterWriteByte(adrs);
        if(status == I2C_1_I2C_MSTR_NO_ERROR) {
            status = I2C_1_I2CMasterWriteByte(data);
            if(status == I2C_1_I2C_MSTR_NO_ERROR) {
                //xprintf( "I2C_1_MasterWriteByte data OK deviceadrs=%02x adrs=%02x data=%02x status=%02x\n",deviceAdrs,adrs,data,status);
                error = FALSE ;
            }
            else {
                errorPrintf( "I2C_1_MasterWriteByte data error. deviceadrs=%02x adrs=%02x data=%02x status=%02x\n",deviceAdrs,adrs,data,status);
            }
        }
        else {
            errorPrintf( "I2C_1_MasterWriteByte data error. deviceadrs=%02x adrs=%02x data=%02x status=%02x\n",deviceAdrs,adrs,data,status);
        }
    }
    else {
        errorPrintf( "deviceadrs=%02x adrs=%02x data=%02x status=%02x\n",deviceAdrs,adrs,data,status);
        //xprintf( __FILE__ " %s I2C_1_MasterSendStart error\n",__FUNCTION__) ;
    }
    I2C_1_I2CMasterSendStop();
    return error ;
}
uint8 ReadRegI2C(uint8 addr_dev, uint8 addr)
{
    uint8 status;
    uint8 data;

    status = I2C_1_I2CMasterSendStart(addr_dev, I2C_1_I2C_WRITE_XFER_MODE);
    if(status == I2C_1_I2C_MSTR_NO_ERROR) {
        status = I2C_1_I2CMasterWriteByte(addr);
        if(status == I2C_1_I2C_MSTR_NO_ERROR){
            status = I2C_1_I2CMasterSendRestart(addr_dev, I2C_1_I2C_READ_XFER_MODE);
            if(status == I2C_1_I2C_MSTR_NO_ERROR){
                data = I2C_1_I2CMasterReadByte(I2C_1_I2C_ACK_DATA);
            }
            else {
                xprintf( __FILE__ " %s I2C_1_MasterSendRestart data error\n",__FUNCTION__ ) ;
            }
        }
        else {
            xprintf( __FILE__ " %s I2C_1_MasterWriteByte address error\n",__FUNCTION__) ;
        }
    }
    else {
        xprintf( __FILE__ " %s I2C_1_MasterSendStart error\n",__FUNCTION__) ;
    }
    I2C_1_I2CMasterSendStop();
    return data;
}

