// copyright(C) KatsuhikoTerawaki CA co.,ltd
//---------------------------
// PSoC5 Includes
//---------------------------
#include <project.h>
//---------------------------
// RTOS Includes
//---------------------------
#include "FreeRTOS.h"
#include "task.h"
#include "queue.h"
#include "semphr.h"

//---------------------------
// API Includes
//---------------------------
#include "mydefine.h"
#include "uart_2.h" //自動生成された include
#include "uart2.h"
static void putcUart2Sub( char c );

//UART_TX_STS_FIFO_NOT_FULL
void initUart2( void )
{
    Clock_1_Start();//UART2の動作クロック
    //UART_2_IntClock_Start();//??

    UART_2_Start();
    UART_2_ClearRxBuffer();
}

void putcUart2( char c )
{
    if( c == '\n' ) {
        putcUart2Sub( '\r' ) ;
        putcUart2Sub( '\n' ) ;
    }
    else {
        putcUart2Sub( c ) ;
    }
}

static void putcUart2Sub( char c )
{
    LOOP() {
        if( UART_2_ReadTxStatus() & UART_2_TX_STS_FIFO_NOT_FULL ) {
            UART_2_WriteTxData( c ) ;
            return ;
        }
        Sleep( 1 ) ;
    }
}
unsigned short getcUart2( void )
{
    unsigned short data ;
    if( UART_2_GetRxBufferSize() != 0 ) {
        data = UART_2_GetByte() ;
        data &= UCHAR_MAX ;
        return data ;
    }
    return NO_CHAR_DATA ;
}
BOOL kbhitUart2( void )
{
    if( UART_2_GetRxBufferSize() != 0 ) {
        return TRUE ;
    }
    return FALSE ;
}

