/*******************************************************************************
* File Name: ACCL_RST_PLUS.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_ACCL_RST_PLUS_H) /* Pins ACCL_RST_PLUS_H */
#define CY_PINS_ACCL_RST_PLUS_H

#include "cytypes.h"
#include "cyfitter.h"
#include "ACCL_RST_PLUS_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    ACCL_RST_PLUS_Write(uint8 value) ;
void    ACCL_RST_PLUS_SetDriveMode(uint8 mode) ;
uint8   ACCL_RST_PLUS_ReadDataReg(void) ;
uint8   ACCL_RST_PLUS_Read(void) ;
uint8   ACCL_RST_PLUS_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define ACCL_RST_PLUS_DRIVE_MODE_BITS        (3)
#define ACCL_RST_PLUS_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - ACCL_RST_PLUS_DRIVE_MODE_BITS))

#define ACCL_RST_PLUS_DM_ALG_HIZ         (0x00u)
#define ACCL_RST_PLUS_DM_DIG_HIZ         (0x01u)
#define ACCL_RST_PLUS_DM_RES_UP          (0x02u)
#define ACCL_RST_PLUS_DM_RES_DWN         (0x03u)
#define ACCL_RST_PLUS_DM_OD_LO           (0x04u)
#define ACCL_RST_PLUS_DM_OD_HI           (0x05u)
#define ACCL_RST_PLUS_DM_STRONG          (0x06u)
#define ACCL_RST_PLUS_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define ACCL_RST_PLUS_MASK               ACCL_RST_PLUS__MASK
#define ACCL_RST_PLUS_SHIFT              ACCL_RST_PLUS__SHIFT
#define ACCL_RST_PLUS_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define ACCL_RST_PLUS_PS                     (* (reg32 *) ACCL_RST_PLUS__PS)
/* Port Configuration */
#define ACCL_RST_PLUS_PC                     (* (reg32 *) ACCL_RST_PLUS__PC)
/* Data Register */
#define ACCL_RST_PLUS_DR                     (* (reg32 *) ACCL_RST_PLUS__DR)
/* Input Buffer Disable Override */
#define ACCL_RST_PLUS_INP_DIS                (* (reg32 *) ACCL_RST_PLUS__PC2)


#if defined(ACCL_RST_PLUS__INTSTAT)  /* Interrupt Registers */

    #define ACCL_RST_PLUS_INTSTAT                (* (reg32 *) ACCL_RST_PLUS__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define ACCL_RST_PLUS_DRIVE_MODE_SHIFT       (0x00u)
#define ACCL_RST_PLUS_DRIVE_MODE_MASK        (0x07u << ACCL_RST_PLUS_DRIVE_MODE_SHIFT)


#endif /* End Pins ACCL_RST_PLUS_H */


/* [] END OF FILE */
