/*******************************************************************************
* File Name: GEIGER_INTRPT.h
* Version 1.70
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/
#if !defined(CY_ISR_GEIGER_INTRPT_H)
#define CY_ISR_GEIGER_INTRPT_H


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void GEIGER_INTRPT_Start(void);
void GEIGER_INTRPT_StartEx(cyisraddress address);
void GEIGER_INTRPT_Stop(void);

CY_ISR_PROTO(GEIGER_INTRPT_Interrupt);

void GEIGER_INTRPT_SetVector(cyisraddress address);
cyisraddress GEIGER_INTRPT_GetVector(void);

void GEIGER_INTRPT_SetPriority(uint8 priority);
uint8 GEIGER_INTRPT_GetPriority(void);

void GEIGER_INTRPT_Enable(void);
uint8 GEIGER_INTRPT_GetState(void);
void GEIGER_INTRPT_Disable(void);

void GEIGER_INTRPT_SetPending(void);
void GEIGER_INTRPT_ClearPending(void);


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the GEIGER_INTRPT ISR. */
#define GEIGER_INTRPT_INTC_VECTOR            ((reg32 *) GEIGER_INTRPT__INTC_VECT)

/* Address of the GEIGER_INTRPT ISR priority. */
#define GEIGER_INTRPT_INTC_PRIOR             ((reg32 *) GEIGER_INTRPT__INTC_PRIOR_REG)

/* Priority of the GEIGER_INTRPT interrupt. */
#define GEIGER_INTRPT_INTC_PRIOR_NUMBER      GEIGER_INTRPT__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable GEIGER_INTRPT interrupt. */
#define GEIGER_INTRPT_INTC_SET_EN            ((reg32 *) GEIGER_INTRPT__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the GEIGER_INTRPT interrupt. */
#define GEIGER_INTRPT_INTC_CLR_EN            ((reg32 *) GEIGER_INTRPT__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the GEIGER_INTRPT interrupt state to pending. */
#define GEIGER_INTRPT_INTC_SET_PD            ((reg32 *) GEIGER_INTRPT__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the GEIGER_INTRPT interrupt. */
#define GEIGER_INTRPT_INTC_CLR_PD            ((reg32 *) GEIGER_INTRPT__INTC_CLR_PD_REG)



#endif /* CY_ISR_GEIGER_INTRPT_H */


/* [] END OF FILE */
