/*******************************************************************************
* File Name: GEIGER_PLS.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_GEIGER_PLS_H) /* Pins GEIGER_PLS_H */
#define CY_PINS_GEIGER_PLS_H

#include "cytypes.h"
#include "cyfitter.h"
#include "GEIGER_PLS_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    GEIGER_PLS_Write(uint8 value) ;
void    GEIGER_PLS_SetDriveMode(uint8 mode) ;
uint8   GEIGER_PLS_ReadDataReg(void) ;
uint8   GEIGER_PLS_Read(void) ;
uint8   GEIGER_PLS_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define GEIGER_PLS_DRIVE_MODE_BITS        (3)
#define GEIGER_PLS_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - GEIGER_PLS_DRIVE_MODE_BITS))

#define GEIGER_PLS_DM_ALG_HIZ         (0x00u)
#define GEIGER_PLS_DM_DIG_HIZ         (0x01u)
#define GEIGER_PLS_DM_RES_UP          (0x02u)
#define GEIGER_PLS_DM_RES_DWN         (0x03u)
#define GEIGER_PLS_DM_OD_LO           (0x04u)
#define GEIGER_PLS_DM_OD_HI           (0x05u)
#define GEIGER_PLS_DM_STRONG          (0x06u)
#define GEIGER_PLS_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define GEIGER_PLS_MASK               GEIGER_PLS__MASK
#define GEIGER_PLS_SHIFT              GEIGER_PLS__SHIFT
#define GEIGER_PLS_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define GEIGER_PLS_PS                     (* (reg32 *) GEIGER_PLS__PS)
/* Port Configuration */
#define GEIGER_PLS_PC                     (* (reg32 *) GEIGER_PLS__PC)
/* Data Register */
#define GEIGER_PLS_DR                     (* (reg32 *) GEIGER_PLS__DR)
/* Input Buffer Disable Override */
#define GEIGER_PLS_INP_DIS                (* (reg32 *) GEIGER_PLS__PC2)


#if defined(GEIGER_PLS__INTSTAT)  /* Interrupt Registers */

    #define GEIGER_PLS_INTSTAT                (* (reg32 *) GEIGER_PLS__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define GEIGER_PLS_DRIVE_MODE_SHIFT       (0x00u)
#define GEIGER_PLS_DRIVE_MODE_MASK        (0x07u << GEIGER_PLS_DRIVE_MODE_SHIFT)


#endif /* End Pins GEIGER_PLS_H */


/* [] END OF FILE */
