/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include <project.h>
#include <FreeRTOS.h>
#include <task.h>
#include <Pin_1.h>

#define NO_FINGER 0xFFFFu

void vBlinkTaskBlue( void *pvParameters ) {
	while(1) {
		Pin_1_Write(~Pin_1_Read());
		vTaskDelay(configTICK_RATE_HZ / 50 ); // ~3 hz		
	}
}

void vBlinkTaskRed( void *pvParameters ) {
	while(1) {
		//Pin_1_Write(~Pin_Blue_LED_Read());
		vTaskDelay(configTICK_RATE_HZ / 5); // 5 hz		
	}
}

void vBlinkTaskGreen( void *pvParameters ) {
	while(1) {
		//Pin_Green_LED_Write(~Pin_Blue_LED_Read());
		vTaskDelay(configTICK_RATE_HZ / 7); // ~7 hz		
	}
}

void prvHardwareSetup();

int main()
{	
    //for(;;){};
	xTaskCreate(vBlinkTaskBlue, (signed portCHAR *) "BlinkBlue", configMINIMAL_STACK_SIZE, NULL, tskIDLE_PRIORITY + 1, NULL);
	xTaskCreate(vBlinkTaskRed, (signed portCHAR *) "BlinkRed", configMINIMAL_STACK_SIZE, NULL, tskIDLE_PRIORITY + 2, NULL);
	xTaskCreate(vBlinkTaskGreen, (signed portCHAR *) "BlinkGreen", configMINIMAL_STACK_SIZE, NULL, tskIDLE_PRIORITY + 3, NULL);
	
	prvHardwareSetup();
    CyGlobalIntEnable;
	vTaskStartScheduler();
	
	return 1; // We should never reach this
}

/* ---------------------------------------------------------------------------
 * FreeRTOS support and configuration functions
 * --------------------------------------------------------------------------- */

void prvHardwareSetup( void )
{
	/* Port layer functions that need to be copied into the vector table. */
	extern void xPortPendSVHandler( void );
	extern void xPortSysTickHandler( void );
	extern void vPortSVCHandler( void );
	extern cyisraddress CyRamVectors[];

	/* Install the OS Interrupt Handlers. */
	CyRamVectors[ 11 ] = ( cyisraddress ) vPortSVCHandler;
	CyRamVectors[ 14 ] = ( cyisraddress ) xPortPendSVHandler;
	CyRamVectors[ 15 ] = ( cyisraddress ) xPortSysTickHandler;
}

void vApplicationStackOverflowHook( xTaskHandle pxTask, signed char *pcTaskName )
{
	/* The stack space has been execeeded for a task, considering allocating more. */
	taskDISABLE_INTERRUPTS();
	for( ;; );
}

void vApplicationMallocFailedHook( void )
{
	/* The heap space has been execeeded. */
	taskDISABLE_INTERRUPTS();
	for( ;; );
}

/* [] END OF FILE */
